=== debian/changelog ===
ignition-gazebo6 (6.16.0-2~focal) focal; urgency=medium

  * ignition-gazebo6 6.16.0-2 release

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Thu, 08 Feb 2024 16:00:57 +0100

ignition-gazebo6 (6.16.0-1~focal) focal; urgency=medium

  * ignition-gazebo6 6.16.0-1 release

 -- Addisu Z. Taddese <addisu@openrobotics.org>  Fri, 12 Jan 2024 18:59:35 -0600

ignition-gazebo6 (6.15.0-1~focal) focal; urgency=medium

  * ignition-gazebo6 6.15.0-1 release

 -- Addisu Z. Taddese <addisu@openrobotics.org>  Wed, 16 Aug 2023 10:11:45 -0500

ignition-gazebo6 (6.14.0-1~focal) focal; urgency=medium

  * ignition-gazebo6 6.14.0-1 release

 -- Jenn Nguyen <jenn@openrobotics.org>  Thu, 29 Dec 2022 12:19:34 -0800

ignition-gazebo6 (6.13.0-1~focal) focal; urgency=medium

  * ignition-gazebo6 6.13.0-1 release

 -- Michael Carroll <michael@openrobotics.org>  Fri, 04 Nov 2022 10:24:47 -0500
