=== debian/control ===
Source: ignition-gazebo6
Maintainer: Jose Luis Rivero <jrivero@osrfoundation.org>
Section: science
Priority: optional
Build-Depends: cmake,
               pkg-config,
               debhelper (>= 11),
               dh-python,
               libtinyxml2-dev,
               libignition-tools-dev,
               libignition-cmake2-dev (>= 2.12.0),
               libignition-common4-av-dev (>= 4.5.1),
               libignition-common4-profiler-dev (>= 4.5.1),
               libignition-common4-events-dev (>= 4.5.1),
               libignition-fuel-tools7-dev,
               libignition-gui6-dev (>= 6.5.0),
               libignition-math6-dev (>= 6.9.0),
               libignition-math6-eigen3-dev (>= 6.9.0),
               libignition-msgs8-dev (>= 8.6.0),
               libignition-plugin-dev,
               libignition-physics5-dev (>= 5.1.0),
               libignition-sensors6-dev (>= 6.6.0),
               libignition-rendering6-dev (>= 6.5.0),
               libignition-transport11-log-dev,
               libignition-utils1-cli-dev,
               libignition-utils1-dev,
               libsdformat12-dev (>= 12.3.0),
               python3-dev,
               python3-pybind11
# doxygen and grapviz are excluded per bug:
# https://github.com/gazebosim/gz-sim/issues/1409
Vcs-Browser: https://github.com/gazebosim/gz-sim
Vcs-Git: https://github.com/gazebo-release/gz-sim6-release
Standards-Version: 4.5.1
Homepage: http://gazebosim.org/

Package: libignition-gazebo6
Architecture: any
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends},
         qml-module-qtqml-models2
Breaks: libignition-gazebo6-6 (>= 6.4.0+ds)
Replaces: libignition-gazebo6-6 (>= 6.4.0+ds)
Multi-Arch: same
Description: Gazebo Sim classes and functions for robot apps - Shared library
 Gazebo Sim is a component in the Gazebo framework, a set of libraries
 designed to rapidly develop robot applications.
 .
 Main shared library

Package: libignition-gazebo6-plugins
Architecture: any
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: Gazebo Sim classes and functions for robot apps - Plugins
 Gazebo Sim is a component in the Gazebo framework, a set of libraries
 designed to rapidly develop robot applications.
 .
 Plugins collection

Package: libignition-gazebo6-dev
Architecture: any
Section: libdevel
Depends: libtinyxml2-dev,
         libignition-tools-dev,
         libignition-cmake2-dev (>= 2.12.0),
         libignition-common4-av-dev (>= 4.5.1),
         libignition-common4-profiler-dev (>= 4.5.1),
         libignition-common4-events-dev (>= 4.5.1),
         libignition-fuel-tools7-dev,
         libignition-gui6-dev (>= 6.5.0),
         libignition-math6-dev (>= 6.9.0),
         libignition-math6-eigen3-dev (>= 6.9.0),
         libignition-msgs8-dev (>= 8.6.0),
         libignition-plugin-dev,
         libignition-physics5-dev (>= 5.1.0),
         libignition-sensors6-dev (>= 6.6.0),
         libignition-rendering6-dev (>= 6.5.0),
         libignition-transport11-log-dev,
         libignition-utils1-cli-dev,
         libignition-utils1-dev,
         libsdformat12-dev (>= 12.3.0),
         libignition-gazebo6 (= ${binary:Version}),
         libignition-gazebo6-plugins (= ${binary:Version}),
         ${misc:Depends}
Multi-Arch: same
Description: Gazebo Sim classes and functions for robot apps - Development files
 Gazebo Sim is a component in the Gazebo framework, a set of libraries
 designed to rapidly develop robot applications.
 .
 Development files

Package: python3-ignition-gazebo6
Architecture: any
Depends: libignition-gazebo6 (= ${binary:Version}),
         python3-distutils,
         python3-pybind11,
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends},
Enhances: libignition-gazebo6
Description: Gazebo Sim classes and functions for robot apps - Development files
 Gazebo Sim is a component in the Gazebo framework, a set of libraries
 designed to rapidly develop robot applications.
 .
 The package contains the Python3 bindings.

Package: libignition-gazebo6-dbg
Architecture: any
Section: debug
Priority: extra
Depends:
     libignition-gazebo6 (= ${binary:Version}),
     ${misc:Depends}
Multi-Arch: same
Description: Gazebo Sim classes and functions for robot apps - Debug symbols
 Gazebo Sim is a component in the Gazebo framework, a set of libraries
 designed to rapidly develop robot applications.
 .
 Debug symbols

Package: libgz-sim6
Depends: libignition-gazebo6 (= ${binary:Version}), ${misc:Depends}
Architecture: all
Priority: optional
Section: oldlibs
Description: transitional package
 It's recommended to use the gz packages going forward.

Package: libgz-sim6-plugins
Depends: libignition-gazebo6-plugins (= ${binary:Version}), ${misc:Depends}
Architecture: all
Priority: optional
Section: oldlibs
Description: transitional package
 It's recommended to use the gz packages going forward.

Package: libgz-sim6-dev
Depends: libignition-gazebo6-dev (= ${binary:Version}), ${misc:Depends}
Architecture: all
Priority: optional
Section: oldlibs
Description: transitional package
 It's recommended to use the gz packages going forward.

Package: python3-gz-sim6
Depends: python3-ignition-gazebo6 (= ${binary:Version}), ${misc:Depends}
Architecture: all
Priority: optional
Section: oldlibs
Description: transitional package
 It's recommended to use the gz packages going forward.

Package: libgz-sim6-dbg
Depends: libignition-gazebo6-dbg (= ${binary:Version}), ${misc:Depends}
Architecture: all
Priority: optional
Section: oldlibs
Description: transitional package
 It's recommended to use the gz packages going forward.
